#define SC_USE_USER_DEFINED_VS_MAIN

#include <std.glsl>
#include <std_vs.glsl>
#include <std_fs.glsl>

#define UnsharpAmount 0.05
#define UnsharpThreshold 0.1

uniform sampler2D scrTex;
uniform vec4 scrTexSize;
uniform vec4 baseColor;
#ifdef VERTEX_SHADER
void main(void){
	sc_Vertex_t v=sc_LoadVertexAttributes();
	sc_ProcessVertex(v);
}
#endif

#ifdef FRAGMENT_SHADER
const float bias=3.7;
const float scale=8.0;

vec4 textureScr(vec2 coo){
	return texture2D(scrTex,coo,bias+0.7);
}
vec4 blur_9(vec2 coo,vec2 d){
	return 0.162103*textureScr(coo)+
		0.120259*(textureScr(coo+vec2(d.x,0.0))+
					textureScr(coo+vec2(0.0,d.y))+
					textureScr(coo+vec2(-d.x,0.0))+
					textureScr(coo+vec2(0.0,-d.y)))+
		0.089216*(textureScr(coo+vec2(d.x,d.y))+
					textureScr(coo+vec2(-d.x,d.y))+
					textureScr(coo+vec2(-d.x,-d.y))+
					textureScr(coo+vec2(d.x,-d.y)));
}

void main(){
	vec2 texCoo=0.5*varScreenPos.xy/varScreenPos.w+0.5;
	vec3 original=texture2D(scrTex,texCoo).rgb;
	vec3 scrColor=original;
	vec3 gauss=blur_9(texCoo,scrTexSize.zw*scale).rgb;

	vec3 difference=gauss -original;

	float val2=clamp(0.5 -difference.g -difference.b,0.0,1.0);
	vec2 case1=vec2(val2,1.0 -val2);
	case1*=case1;
	case1*=case1;
	case1=case1*case1*128.0;

	float val2mixAmount=step(val2,0.5);
	val2=mix(1.0 -case1.y,case1.x,val2mixAmount);

	const vec3 Con1=vec3(-0.391731,1.4554,-0.0637);
	const vec3 Con2=vec3(0.391731,-0.4554,0.0637);
	vec3 mult1=Con2*val2+Con1;
	original=(mult1.x*original+mult1.y)*original+mult1.z;

	float mixAmount=step(UnsharpThreshold*UnsharpThreshold,dot(difference,difference));
	gl_FragColor=vec4(mix(scrColor,original-(mixAmount*UnsharpAmount)*difference,baseColor.a),1.0);
}
#endif

#if sc_IsEditor
#error This is an exported shader. Please do not use shaders in Studio that have already been exported to a lens! Only use fresh shaders,presets,or shaders from existing Studio projects!
#endif

/// Exported with Lens Studio 4.0.1.0
